#define IR_PIN 4
#define SENSOR_PIN A3
#define LED_PIN 1
#define FEEDBACK_PIN 2

#define SAMPLE_SIZE 10
#define THRESHOLD 100


bool lastState = false;

void setup() {
  pinMode(IR_PIN, OUTPUT);
  pinMode(LED_PIN, OUTPUT);
  pinMode(FEEDBACK_PIN, OUTPUT);
}

void loop() {
  
  int readingOff = 0;
  int readingOn = 0;
  
  for (int i = 0; i < SAMPLE_SIZE; i++)
  {
    readingOff += analogRead(SENSOR_PIN);
    digitalWrite(IR_PIN, HIGH);
    readingOn += analogRead(SENSOR_PIN);
    digitalWrite(IR_PIN, LOW);
  }
  
  int readingOff_Avg = readingOff / SAMPLE_SIZE;
  int readingOn_Avg = readingOn / SAMPLE_SIZE;
  int difference = readingOn_Avg - readingOff_Avg;
  
  bool state;
  
  if(difference >= THRESHOLD) {
    state = true;
  } else {
    state = false;
  }

  if (state != lastState) {
    if (state) { 
      digitalWrite(LED_PIN, HIGH);
      digitalWrite(FEEDBACK_PIN, HIGH); 
    } else {
      digitalWrite(LED_PIN, LOW); 
      digitalWrite(FEEDBACK_PIN, LOW);
    }
  }
  
  lastState = state; 
}
